package be.iminds.ilabt.jfed.restapi.client;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.FedmonApiCommon;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.JsonLdObjects;
import be.iminds.ilabt.jfed.lowlevel.AnyCredential;
import be.iminds.ilabt.jfed.restapi.json.Experiment;
import be.iminds.ilabt.jfed.util.JFedTrustStore;
import org.apache.http.client.utils.URIBuilder;

import java.security.PrivateKey;
import java.security.cert.X509Certificate;
import java.util.List;

/**
 * FedmonWebApiClientConfig
 */
public interface JFedRestApiClientConfig {
    URIBuilder getUriBuilder(Class<? extends JsonLdObjects.BasicLdObject> objectClass, boolean read);

    URIBuilder getUriBuilder(Class<? extends JsonLdObjects.BasicLdObject> objectClass, String pathEnd, boolean read);

    JFedTrustStore getTrustStore();
    List<X509Certificate> getUserCertificateChain();
    PrivateKey getUserPrivateKey();
}
